package com.unipi.talepis;

import java.util.*;

public class Main {
	private static Random random = new Random();
    public static void main(String[] args) {
	    calculateSpeed("LinkedList",Main::linkedListTest);
	    calculateSpeed("ArrayList",Main::arrayListTest);
	    calculateSpeed("Array",Main::arrayTest);
	    calculateSpeed("Set", Main::setTest);
	    calculateSpeed("Map",Main::mapTest);
    }
    private static void calculateSpeed(String s, Runnable r){
		long startTime = System.nanoTime();
		r.run();
		long endTime = System.nanoTime();
		double duration = (double) (endTime-startTime)/1000000000.0;
		System.out.println("Duration of "+s+" :"+duration);
	}
    private static void linkedListTest(){
		List<String> list = new LinkedList<>();
		for (int i=0;i<10000000;i++){
			list.add(String.valueOf(random.nextInt(1000000)));
		}
	}
	private static void arrayListTest(){
		List<String> list = new ArrayList<>(10000000);
		for (int i=0;i<10000000;i++){
			list.add(String.valueOf(random.nextInt(1000000)));
		}
	}
	private static void arrayTest(){
		String[] array = new String[10000000];
		for (int i=0;i<10000000;i++){
			array[i] = String.valueOf(random.nextInt(1000000));
		}
	}
	private static void setTest(){
		Set<String> set = new HashSet<>();
		for (int i=0;i<10000000;i++){
			set.add(String.valueOf(random.nextInt(1000000)));
		}
	}
	private static void mapTest(){
		Map<String,String> map = new HashMap<>();
		for (int i=0;i<10000000;i++){
			map.put(String.valueOf(i),String.valueOf(random.nextInt(1000000)));
		}
	}
    private static void testMethod(){
		long startTime = System.nanoTime();
		Long sum = 0l;
		for (int i=0;i<Integer.MAX_VALUE;i++){
			sum+=i;
		}
		System.out.println(sum);
		long endTime = System.nanoTime();
		double duration = (double) (endTime-startTime)/1000000000.0;
		System.out.println("Duration :"+duration);
		System.out.println("------------------------");
		startTime = System.nanoTime();
		long sum2 = 0l;
		for (int i=0;i<Integer.MAX_VALUE;i++){
			sum2+=i;
		}
		System.out.println(sum2);
		endTime = System.nanoTime();
		duration = (double) (endTime-startTime)/1000000000.0;
		System.out.println("Duration :"+duration);
	}
}
